=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-02-21 05:34:53 +0000
+++ drizzled/show.cc	2009-02-27 22:19:04 +0000
@@ -45,6 +45,8 @@
 #include <string>
 #include <iostream>
 #include <sstream>
+#include <vector>
+#include <algorithm>
 
 using namespace std;
 
@@ -1219,6 +1221,7 @@
 *****************************************************************************/
 
 static DYNAMIC_ARRAY all_status_vars;
+static vector<SHOW_VAR> all_status_vars;
 static bool status_vars_inited= 0;
 int show_var_cmp(const void *var1, const void *var2)
 {
@@ -1270,18 +1273,23 @@
   int res= 0;
   if (status_vars_inited)
     pthread_mutex_lock(&LOCK_status);
-  if (!all_status_vars.buffer && // array is not allocated yet - do it now
-      my_init_dynamic_array(&all_status_vars, sizeof(SHOW_VAR), 200, 20))
-  {
-    res= 1;
-    goto err;
-  }
+  //if (!all_status_vars.buffer && // array is not allocated yet - do it now
+  //    my_init_dynamic_array(&all_status_vars, sizeof(SHOW_VAR), 200, 20))
+  //{
+   // res= 1;
+   // goto err;
+  //}
   while (list->name)
-    res|= insert_dynamic(&all_status_vars, (unsigned char*)list++);
-  res|= insert_dynamic(&all_status_vars, (unsigned char*)list); // appending NULL-element
-  all_status_vars.elements--; // but next insert_dynamic should overwite it
+    //res|= insert_dynamic(&all_status_vars, (unsigned char*)list++);
+    all_status_vars.push_back(list++);
+  //res|= insert_dynamic(&all_status_vars, (unsigned char*)list); // appending NULL-element
+  all_status_vars.push_back(list); // appending NULL-element
+  //all_status_vars.elements--; // but next insert_dynamic should overwite it
+  /* not sure about this^^ statement */
   if (status_vars_inited)
-    sort_dynamic(&all_status_vars, show_var_cmp);
+    //sort_dynamic(&all_status_vars, show_var_cmp);
+    sort(all_status_vars.begin(), all_status_vars.end(),
+           show_var_cmp);
 err:
   if (status_vars_inited)
     pthread_mutex_unlock(&LOCK_status);
@@ -1299,18 +1307,28 @@
 void init_status_vars()
 {
   status_vars_inited=1;
-  sort_dynamic(&all_status_vars, show_var_cmp);
+  //sort_dynamic(&all_status_vars, show_var_cmp);
+  sort(all_status_vars.begin(), all_status_vars.end(),
+         show_var_cmp);
 }
 
 void reset_status_vars()
 {
-  SHOW_VAR *ptr= (SHOW_VAR*) all_status_vars.buffer;
-  SHOW_VAR *last= ptr + all_status_vars.elements;
-  for (; ptr < last; ptr++)
+  //SHOW_VAR *ptr= (SHOW_VAR*) all_status_vars.buffer;
+  //SHOW_VAR *last= ptr + all_status_vars.elements;
+  //for (; ptr < last; ptr++)
+  //{
+    /* Note that SHOW_LONG_NOFLUSH variables are not reset */
+   // if (ptr->type == SHOW_LONG)
+   //   *(ulong*) ptr->value= 0;
+  //}
+  vector<SHOW_VAR>::iterator p= all_status_vars.begin();
+  while (p != all_status_vars.end())
   {
     /* Note that SHOW_LONG_NOFLUSH variables are not reset */
-    if (ptr->type == SHOW_LONG)
-      *(ulong*) ptr->value= 0;
+    if (*p->type == SHOW_LONG)
+      *p->value= 0;
+    ++p;
   }
 }
 
@@ -1323,10 +1341,10 @@
     deletes everything from the all_status_vars[] even if some
     remove_status_vars were forgotten
 */
-void free_status_vars()
-{
-  delete_dynamic(&all_status_vars);
-}
+//void free_status_vars()
+//{
+ // delete_dynamic(&all_status_vars);
+//}
 
 /*
   Removes an array of SHOW_VAR entries from the output of SHOW STATUS
@@ -1347,13 +1365,16 @@
   if (status_vars_inited)
   {
     pthread_mutex_lock(&LOCK_status);
-    SHOW_VAR *all= dynamic_element(&all_status_vars, 0, SHOW_VAR *);
-    int a= 0, b= all_status_vars.elements, c= (a+b)/2;
+    //SHOW_VAR *all= dynamic_element(&all_status_vars, 0, SHOW_VAR *);
+    SHOW_VAR *all= all_status_vars.front();
+    //int a= 0, b= all_status_vars.elements, c= (a+b)/2;
+    int a= 0, b= all_status_vars.size(), c= (a+b)/2;
 
     for (; list->name; list++)
     {
       int res= 0;
-      for (a= 0, b= all_status_vars.elements; b-a > 1; c= (a+b)/2)
+      //for (a= 0, b= all_status_vars.elements; b-a > 1; c= (a+b)/2)
+      for (a= 0, b= all_status_vars.size(); b-a > 1; c= (a+b)/2)
       {
         res= show_var_cmp(list, all+c);
         if (res < 0)
@@ -1366,16 +1387,18 @@
       if (res == 0)
         all[c].type= SHOW_UNDEF;
     }
-    shrink_var_array(&all_status_vars);
+    //shrink_var_array(&all_status_vars);
     pthread_mutex_unlock(&LOCK_status);
   }
   else
   {
-    SHOW_VAR *all= dynamic_element(&all_status_vars, 0, SHOW_VAR *);
+    //SHOW_VAR *all= dynamic_element(&all_status_vars, 0, SHOW_VAR *);
+    SHOW_VAR *all= all_status_vars.front();
     uint32_t i;
     for (; list->name; list++)
     {
-      for (i= 0; i < all_status_vars.elements; i++)
+      //for (i= 0; i < all_status_vars.elements; i++)
+      for (i= 0; i < all_status_vars.size(); i++)
       {
         if (show_var_cmp(list, all+i))
           continue;
@@ -1383,7 +1406,7 @@
         break;
       }
     }
-    shrink_var_array(&all_status_vars);
+    //shrink_var_array(&all_status_vars);
   }
 }
 
@@ -3565,7 +3588,8 @@
   if (option_type == OPT_GLOBAL)
     calc_sum_of_all_status(&tmp);
   res= show_status_array(session, wild,
-                         (SHOW_VAR *)all_status_vars.buffer,
+                         //(SHOW_VAR *)all_status_vars.buffer,
+                         (SHOW_VAR *)*all_status_vars.begin(),
                          option_type, tmp1, "", tables->table,
                          upper_case_names);
   pthread_mutex_unlock(&LOCK_status);

